https://www.luogu.org/problemnew/show/P2751
题解:贪心
从前往后贪心,用f[i]记录第i个零件完成的最小时间
定义一个结构体,记录
v:每一台机器完成一个零件的时间和
s:完成下一个零件到达的时间点(会不断变化)
从前往后每次找完都要排序
最后输出f[n]
f数组肯定是f[i]<=f[i+1],为了让最长时间尽量少,我们就尽量
让A,B连个步骤的总时间平均,,所以要 从后往前 找 查找的方
式和前面的几乎一样,但要记得+f[i]
/*
*@Author: STZG
*@Language: C++
*/
#include <bits/stdc++.h>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<cstring>
#include<cstdio>
#include<string>
#include<vector>
#include<bitset>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<list>
#include<map>
#include<set>
//#define DEBUG
#define RI register int
#define endl "\n"
using namespace std;
typedef long long ll;
//typedef __int128 lll;
const int N=1000+10;
const int M=100000+10;
const int MOD=1e9+7;
const double PI = acos(-1.0);
const double EXP = 1E-8;
const int INF = 0x3f3f3f3f;
int s,t,n,m,k,p,l,r,u,v,w,a,b;
int ans,cnt,flag,temp,sum;
struct node{
int s,v;
//小根堆,在栈里面自动排序,非常有用,值得记一下
bool operator<(node k)const{
if(s>k.s) return true;//这里把完成时间从小到大排一次序
return false;
}
}x;
priority_queue<node> q;//栈,想学贪心必先学栈
int f[N];//记录第i个零件完成的最小时间
int main()
{
#ifdef DEBUG
freopen("input.in", "r", stdin);
//freopen("output.out", "w", stdout);
#endif
//ios::sync_with_stdio(false);
//cin.tie(0);
//cout.tie(0);
//scanf("%d",&t);
//int T=0;
scanf("%d%d%d",&n,&a,&b);
for(int i=1;i<=a;i++){
scanf("%d",&x.v);
x.s=x.v;
//这里本来可以为0,但是为了让排序方便很多
//而且这样可以避免很多不必要的情况发生
//比如说某一台机器运转时间比另一台高出了很多
q.push(x);//放进栈
}
for(int i=1;i<=n;i++){//从前往后
x=q.top();//取出最小值
q.pop();
f[i]=x.s;//记录
x.s=x.s+x.v;//为下一个做准备
q.push(x);//继续放进栈里面排序
}
while(!q.empty()) q.pop();//找完了A,再来找B,所以得把q全部弹出去
for(int i=1;i<=b;i++){
scanf("%d",&x.v);//和上面几乎一样的操作
x.s=x.v;
q.push(x);
}
int t=0;//t记录用时最长的那个
for(int i=n;i>=1;i--){//从后往前
x=q.top();
q.pop();
t=max(t,x.s+f[i]);//记得+f[i],x不用自己加f[i]
x.s=x.s+x.v;
q.push(x);
}
printf("%d %d\n",f[n],t);//输出
#ifdef DEBUG
printf("Time cost : %lf s\n",(double)clock()/CLOCKS_PER_SEC);
#endif
//cout << "Hello world!" << endl;
return 0;
}